
(* "import" exceptions, in case you don't have them in their file*)
exception BadDivisors of int * int
let bad_divisors n m = raise (BadDivisors (n,m))
exception BadPi of int
let bad_pi (n:int) = raise (BadPi n)
exception BadArg of int
let bad_arg (n:int) = raise (BadArg n)

(* Give initial values for required functions and variables, so that if you 
    don't include them, they'll still be able to be referenced in the tests
   Also define a few of our implementations of required items *)
let print_survey () = ()
let prob2a : string = "Problem 2a unimplemented"
let prob2b : float = nan
let rec prob2c x = Printf.printf "No such function!\n"; ' '
let rec prob2d y z = Printf.printf "No such function!\n"; false
let prob3a : bool = false
let exp3a : string = "no answer"
let prob3b : int = 0xdeadbeef
let exp3b : string = "no answer"
let prob3c : int = 0xdeadbeef
let exp3c : string = "no answer"
let prob4a : int = 0xdeadbeef
let warn4a : string = "no answer"
let f (a:int) (b:int) : float = nan
let rec prob4b (x:float) (y:int) = prob4b x y
let exp4b : string = "no answer"
let exp4c : string = "no answer"

let rec few_divisors (n: int) (m:int) : bool = Printf.printf "No such function!\n"; false

let sin_pi (i:int) : float = Printf.printf "No such function!\n"; nan

let collatz (n:int) : int = Printf.printf "No such function!\n"; -1

(* 
OCaml, by default, exports each file foo.ml as a module Foo
so this is just importing all of your solutions
*)

open A1

(* given a check and a message, if the check fails print the message.
 * in either case, return the result of the check
*)
let assert326 ( cond: bool ) (msg : string) : bool =
  if not cond then Printf.printf "%s\n" msg ;
  flush stdout ; 
  cond

(* 
Pretty printing for transcripts
 *)

let print_header ( prob: string) : unit =
  let row = "----------------------------------------\n" in
  Printf.printf "\n%s%s\n%s" row prob row ;
  flush stdout

(* Testing Problem 3 *)
(* again, prob 3a-3c won't compile if not corrected, but check anyway to
 * maximize auto-grading *)
let _ = print_header ( "Problem 3" )
let _ = (assert326 ( prob3a = true ) 
                           "3a should be true")
let _ = (assert326 (prob3b = 55) "3b should be 55")
let _ = (assert326 (prob3c = 55) "3c should be 55")

let _ = print_string "Tests complete\n"

(* Testing Problem 5 *)
let _ = print_header ( "Problem 5" )
let _ = (assert326 ( few_divisors 17 3 )
                              "Incorrect answer for arguments: 17 3")

let _ = (assert326 ( not (few_divisors 4 3)  )
                              "Incorrect answer for arguments: 4 3")

let _ = (assert326 ( try few_divisors 4 4 with
  BadDivisors (n,m) -> false
| _ -> false)
                              "Incorrect answer for arguments: 4 4")

let _ = (assert326 ( try not (few_divisors 18 0) with 
  BadDivisors (n,m) -> false
| _ -> false)
                                   "Incorrect answer for arguments: 18 0")

let _ = (assert326 ( try not (few_divisors 18 1) with 
                                       BadDivisors (n,m) -> false
                                     | _ -> false)
                              "Incorrect answer for arguments: 18 1")

let _ = (assert326 ( try not (few_divisors 18 2) with 
                                       BadDivisors (n,m) -> false
                                     | _ -> false)
                              "Incorrect answer for arguments: 18 2")

let _ = (assert326 ( not (few_divisors 18 3)  )
                              "Incorrect answer for arguments: 18 3")

let _ = (assert326 ( not (few_divisors 18 4)  )
                              "Incorrect answer for arguments: 18 4")

let _ = (assert326 ( not (few_divisors 18 5)  )
                              "Incorrect answer for arguments: 18 5")

let _ = (assert326 ( not (few_divisors 18 6)  )
                              "Incorrect answer for arguments: 18 6")

let _ = (assert326 ( few_divisors 18 7  )
                              "Incorrect answer for arguments: 18 7")

let _ = (assert326 ( try few_divisors 18 19 with
                                       BadDivisors (n,m) -> false
| _ -> false)
                              "Incorrect answer for arguments: 18 19")

let _ = (assert326 ( try not ( few_divisors 1 0) with 
                                       BadDivisors (n,m) -> false
                                     | Division_by_zero -> false
                                     | _ -> false)
                                   "Incorrect answer for arguments: 1 0")

let _ = (assert326 ( try not ( few_divisors 1 1) with 
                                       BadDivisors (n,m) -> false
                                     | Division_by_zero -> false
                                     | _ -> false)
                                   "Incorrect answer for arguments: 1 1")

let _ = (assert326 ( try ( few_divisors 1 2) with 
                                       BadDivisors (n,m) -> false
                                     | Division_by_zero -> false
                                     | _ -> false)
                                   "Incorrect answer for arguments: 1 2")

let _ = (assert326 ( try few_divisors 0 10 with 
  BadDivisors (n,m) -> true
| _ -> false) "Does not throw correct exception for arguments 0 10")

let _ = (assert326 ( try few_divisors (-1) 10 with 
  BadDivisors (n,m) -> true
| _ -> false) "Does not throw correct exception for arguments -1 10")

let _ = (assert326 ( try few_divisors 10 (-1) with 
  BadDivisors (n,m) -> true
| _ -> false) "Does not throw correct exception for arguments 10 -1")


let _ = print_string "Tests complete\n"

(* Testing Problem 6a *)

(* compare floats down to the point of floating point figments *)
let cmp_float (f1:float) (f2:float) : bool =
  let d = f1 -. f2 in
  abs_float d < 0.0000000001

let _ = print_header ( "Problem 6a" )

let result = try sin_pi 0 with
               | BadPi n -> print_string "sin_pi 0 threw BadPi -- "; nan
let _ = (assert326 ( cmp_float result 3. )
               ("Incorrect answer for argument 0: "^(string_of_float result)))
let result = sin_pi 1
let _ = (assert326 ( cmp_float result 3.14112000805986735 )
               ("Incorrect answer for argument 1: "^(string_of_float result)))
let result = sin_pi 2
let _ =   (assert326 ( cmp_float result 3.14159265357219564 )
              ("Incorrect answer for argument 2: "^(string_of_float result)))
let result = sin_pi 3
let _ =   (assert326 ( cmp_float result 3.14159265358979312 )
              ("Incorrect answer for argument 3: "^(string_of_float result)))

let _ =   (assert326 ( try sin_pi (-1) < 0. with 
  BadPi n -> true
| _ -> false) "Does not throw correct exception for argument -1")

let _ = print_string "Tests complete\n"

(* Testing Problem 7 *)
let _ = print_header ( "Problem 7" )

let result = (collatz (-3))
let _ =   (assert326 (result = 0)
              ("Incorrect answer for argument -3: "^(string_of_int result)))

let result = collatz 2
let _ =   (assert326 (result = 2)
              ("Incorrect answer for argument 2: "^(string_of_int result)))

let result = collatz 12
let _ =   (assert326 (result = 10)
              ("Incorrect answer for argument 12: "^(string_of_int result)))

let result = collatz 27
let _ =   (assert326 (result = 112)
              ("Incorrect answer for argument 27: "^(string_of_int result)))

let _ = print_string "Tests complete\n"
